//-------------------------------------------------------------------
// code03eA.c
//-------------------------------------------------------------------

#include <PalmOs.h>
#include <HostControl.h>

#include "ELaunch.h"
#include "Resource.h"

/*##################################################################*/

typedef struct
{
  Char	      dbName[dmDBNameLength];
  UInt32      dbType;
  UInt32      dbCreator;
  TPrefs      Prefs;
  UInt16      wSize;
  UInt16      LnchCardNo;
  LocalID     LnchDbID;
} TVars;

/*##################################################################*/
Err MySysAppLaunch ( UInt16 cardNo, LocalID dbID, UInt16 launchFlags, 
		     UInt16 cmd, MemPtr cmdPBP, UInt32* resultP )
/*##################################################################*/
{
  Err (*oldtrap)( UInt16, LocalID, UInt16, UInt16, MemPtr, UInt32* );

  if ( launchFlags & sysAppLaunchFlagNewGlobals )
  {
    TVars *vars = (TVars*)MemPtrNew( sizeof( *vars ) );

    if ( NULL != vars )
    {
      if ( 0 == DmDatabaseInfo( cardNo, dbID, vars->dbName, NULL, NULL, NULL, NULL,
        			NULL, NULL, NULL, NULL, &(vars->dbType), &(vars->dbCreator) ) )
      {
        if ( vars->dbType == TYPE_APP )
        {
          vars->wSize = sizeof( vars->Prefs );

          if ( APPPREFVER == PrefGetAppPreferences( HACKID, APPPREFID, &(vars->Prefs), &(vars->wSize), true ) )
          {
	    if ( vars->Prefs.CheckBoxes[ cIgnoreLauncher ] && vars->dbCreator == PrefGetPreference( prefLauncherAppCreator ) ) 
	    {
	      vars->LnchCardNo = vars->Prefs.LnchCardNo1;
	      vars->Prefs.LnchCardNo1 = vars->Prefs.LnchCardNo0;
	      vars->Prefs.LnchCardNo0 = vars->LnchCardNo;

	      vars->LnchDbID = vars->Prefs.LnchDbID1;
	      vars->Prefs.LnchDbID1 = vars->Prefs.LnchDbID0;
	      vars->Prefs.LnchDbID0 = vars->LnchDbID;
	    }
	    else
	      if ( vars->dbCreator != 'trg9' ) // Ignore FlashPro
	      {
	        vars->Prefs.LnchCardNo1 = vars->Prefs.LnchCardNo0;
	        vars->Prefs.LnchCardNo0 = cardNo;
	        vars->Prefs.LnchDbID1 = vars->Prefs.LnchDbID0;
	        vars->Prefs.LnchDbID0 = dbID;
	      }

	    PrefSetAppPreferences( HACKID, APPPREFID, APPPREFVER, &(vars->Prefs), sizeof( vars->Prefs ), true );
	  }
	}
      }

      MemPtrFree( vars );
    }
  }

  FtrGet( HACKID, HACKINDEX3, (UInt32*)&oldtrap );
  return oldtrap( cardNo, dbID, launchFlags, cmd, cmdPBP, resultP );
}
/*##################################################################*/
