//-------------------------------------------------------------------
// code07d0.c
//-------------------------------------------------------------------

#include <PalmOs.h>
#include <HostControl.h>

#include "ELaunch.h"
#include "Resource.h"

/*##################################################################*/

void		AddToDbList		    ( TDBlist *list, UInt16 Count, UInt16 Start, MemHandle From, UInt32 CreatorFlag );
void	      	AppListChanged	  	    ( TGlobals *pVars );
Int16		DBcompare		    ( SysDBListItemType* c1, SysDBListItemType* c2, Int32 l );
Int16		DBList_GetIndexFromCreator  ( TDBlist *list, UInt32 creator );
Char*		GetActionText		    ( TGlobals *pVars, UInt32 dwAction );
ControlPtr	GetFrmObject	  	    ( TGlobals *pVars, UInt16 wField );
Char*		GetLstText		    ( TGlobals *pVars, UInt16 wLst, int Index );
void		ListsChanged	  	    ( TGlobals *pVars );
void		MyListDraw		    ( Int16 itemNum, RectangleType *bounds, Char **itemsText );
void		MyLstSetSelection	    ( ListPtr List, int Item );
void		OtherListChanged  	    ( TGlobals *pVars );
void		ReadStrokeKey	  	    ( TGlobals *pVars );
void		SetTab		  	    ( TGlobals *pVars );
void		SetKey			    ( TGlobals *pVars, int iKeyPrim, int iKeySec, int iKeyStyle );
void		SetStroke		    ( TGlobals *pVars, int iFrom, int iTo );
void		SetTrigList		    ( TGlobals *pVars, UInt16 Index, UInt16 Ctrl );

/*##################################################################*/

asm ( " bra MainForm" );

/*##################################################################*/

const static char gszP_Keys[] = "[%d] %s: %s %s%s%s\n";
const static char gszP_KeysAnd[] = " & ";
const static char gszP_Stylus[] = "[%d] %s: %s > %s\n";
const static char gszEmpty[] = "";

const static char gszWait[] = "Loading file list, please wait ...";

#define gszWaitX  24
#define gszWaitY  75

/*##################################################################*/
Boolean MainForm	( EventPtr event )
/*##################################################################*/
{
Boolean fHandled = false;
register TGlobals *pVars;
TGlobals *pTempVars;

pTempVars = NULL;
FtrGet( HACKID, FTR_VARS, (UInt32*)&pTempVars );

ReadStrokeKey( pVars = pTempVars );
  
switch ( event->eType ) 
  {
  case frmOpenEvent:
    {
    int	i;
    MemHandle AppList, DAList, PanlList;
    UInt16 AppCnt, DACnt, PanlCnt;
    Boolean AreDAs;
    UInt16 wSize;

    WinDrawChars( gszWait, sizeof( gszWait ) - 1, gszWaitX, gszWaitY );

    pVars = (TGlobals*)MemPtrNew( sizeof( *pVars ) );
    FtrSet( HACKID, FTR_VARS, (UInt32)pVars );

    MemSet( &(pVars->Prefs), sizeof( pVars->Prefs ), 0 );

    wSize = sizeof( pVars->Prefs );
    if ( APPPREFVER != PrefGetAppPreferences( HACKID, APPPREFID, &(pVars->Prefs), &wSize, true ) )
      MemSet( &(pVars->Prefs), sizeof( pVars->Prefs ), 0 );

    // Create db list

    SysCreateDataBaseList( TYPE_APP, 0, &AppCnt, &AppList, true );
    SysCreateDataBaseList( TYPE_PANL, 0, &PanlCnt, &PanlList, true );
    AreDAs = SysCreateDataBaseList( TYPE_DA, 0, &DACnt, &DAList, true );
    		       
    pVars->dbList.dbCount = AppCnt + PanlCnt + DACnt;
    pVars->dbList.dbInfoArray  = MemPtrNew( pVars->dbList.dbCount * sizeof( pVars->dbList.dbInfoArray[0] ) );
    pVars->dbList.listItemPtrs = MemPtrNew( pVars->dbList.dbCount * sizeof( pVars->dbList.listItemPtrs[0] ) );

    AddToDbList( &(pVars->dbList), AppCnt, 0, AppList, 0 );
    AddToDbList( &(pVars->dbList), PanlCnt, AppCnt, PanlList, PANLCREATORFLAG );

    if ( AreDAs )
      AddToDbList( &(pVars->dbList), DACnt, AppCnt + PanlCnt, DAList, DACREATORFLAG );

    SysQSort( pVars->dbList.dbInfoArray,
              pVars->dbList.dbCount,
              sizeof( pVars->dbList.dbInfoArray[0] ),
              (CmpFuncPtr)DBcompare, 0 );

    for ( i = pVars->dbList.dbCount ; --i >= 0 ; )
      pVars->dbList.listItemPtrs[i] = pVars->dbList.dbInfoArray[i].name;

    WinEraseChars( gszWait, sizeof( gszWait ) - 1, gszWaitX, gszWaitY );

    // Create db list - end

    pVars->frm = FrmGetActiveForm();

    LstSetListChoices( pVars->pListApp = (ListPtr)GetFrmObject( pVars, IDC_LIST_APP ),
		       pVars->dbList.listItemPtrs, pVars->dbList.dbCount );

    LstSetDrawFunction ( pVars->pListApp, (ListDrawDataFuncPtr)MyListDraw );
 
    for ( i = cCOUNT ; --i >= 0 ; )
      CtlSetValue( GetFrmObject( pVars, IDC_1stCHECKBOX + i ), pVars->Prefs.CheckBoxes[ i ] );

    pVars->pListTo = (ListPtr)GetFrmObject( pVars, IDC_LIST_TO );
    pVars->pListFrom = (ListPtr)GetFrmObject( pVars, IDC_LIST_FROM );

    pVars->pListKeyPrim = (ListPtr)GetFrmObject( pVars, IDC_LIST_KEYPRIM );
    pVars->pListKeyStyle = (ListPtr)GetFrmObject( pVars, IDC_LIST_KEYSTYLE );
    pVars->pListKeySec = (ListPtr)GetFrmObject( pVars, IDC_LIST_KEYSEC );

    pVars->pSummary = (FieldPtr)GetFrmObject( pVars, IDC_SUMMARY );

    SetKey( pVars, pVars->Prefs.iKeyPrim, pVars->Prefs.iKeySec, pVars->Prefs.iKeyStyle );
    SetStroke( pVars, pVars->Prefs.iStrokeFrom, pVars->Prefs.iStrokeTo );


  SETTABandREADSTROKEKEYandUPDATE:
    SetTab( pVars );

  READSTROKEKEYandUPDATE:
    ReadStrokeKey( pVars );
    ListsChanged( pVars );
    fHandled = true;
    break;
    }

  case frmCloseEvent:
    {
      FldFreeMemory( pVars->pSummary );

      MemPtrFree( pVars->dbList.dbInfoArray );
      MemPtrFree( pVars->dbList.listItemPtrs );
      MemPtrFree( pVars );
      FtrUnregister( HACKID, FTR_VARS );
      break;
    }

  case EVENT_STROKE:
    {
      if ( tSTYLUS != pVars->Prefs.iTab )
      {
        pVars->Prefs.iTab = tSTYLUS;
        SetTab( pVars );
      }

      SetStroke( pVars, event->data.generic.datum[0], event->data.generic.datum[1] );

      SndPlaySystemSound( sndClick );
      goto READSTROKEKEYandUPDATE;
    }

  case EVENT_KEY:
    {
      if ( tKEYS != pVars->Prefs.iTab )
      {
        pVars->Prefs.iTab = tKEYS;
        SetTab( pVars );
      }

      SetKey( pVars, event->data.generic.datum[0], event->data.generic.datum[1], event->data.generic.datum[2] );

      SndPlaySystemSound( sndClick );
      goto READSTROKEKEYandUPDATE;
    }

  case popSelectEvent:
    switch( event->data.popSelect.listID )
      {
      case IDC_LIST_TAB:
	pVars->Prefs.iTab = event->data.popSelect.selection;
        goto SETTABandREADSTROKEKEYandUPDATE;

      case IDC_LIST_APP:
	AppListChanged( pVars );
    	fHandled = true;
    	break;

      case IDC_LIST_OTHER:
	OtherListChanged( pVars );
    	fHandled = true;
    	break;
      }
    break;

  case lstSelectEvent:
    switch( event->data.ctlEnter.controlID )
      {
      case IDC_LIST_FROM:	      
      case IDC_LIST_TO:	      
      case IDC_LIST_KEYPRIM:	      
      case IDC_LIST_KEYSTYLE:	      
      case IDC_LIST_KEYSEC:	      
        ListsChanged( pVars );
    	fHandled = true;
    	break;
      }
    break;

  case keyDownEvent:
    if ( pVars->Prefs.iTab == tSUMMARY )
      switch( event->data.keyDown.chr )
      {
	case vchrPageUp:
	  goto IDC_SUMMARY_UPlabel;

	case vchrPageDown:
	  goto IDC_SUMMARY_DOWNlabel;
      }
    break;

  case ctlRepeatEvent:
    switch( event->data.ctlRepeat.controlID )
    {
      case IDC_SUMMARY_UP:
      IDC_SUMMARY_UPlabel:
	FldScrollField( pVars->pSummary, 1, winUp );
	break;

      case IDC_SUMMARY_DOWN:
      IDC_SUMMARY_DOWNlabel:
	if ( FldScrollable( pVars->pSummary, winDown ) )
	  FldScrollField( pVars->pSummary, 1, winDown );
	break;
    }
    break;

  case ctlSelectEvent:
    switch( event->data.ctlEnter.controlID )
    {

#ifndef _NOHELP
      case IDHELP:
	FrmHelp( IDS_HELP_STYLUS + pVars->Prefs.iTab );
    	fHandled = true;
    	break;
#endif

      case IDOK:
	PrefSetAppPreferences( HACKID, APPPREFID, APPPREFVER,
			       &(pVars->Prefs), sizeof( pVars->Prefs ), true );

      case IDCANCEL:
        FrmGotoForm( 9000 );
    	fHandled = true;
    	break;

      case IDC_NONE:
	*pVars->pdwStrokeKey = 0;
    	fHandled = true;
    	break;

      case IDC_APP:
	AppListChanged( pVars );
    	fHandled = true;
    	break;

      case IDC_OTHER:
	OtherListChanged( pVars );
    	fHandled = true;
    	break;

      case IDC_1stCHECKBOX ... ( IDC_1stCHECKBOX + cCOUNT - 1 ) :
	pVars->Prefs.CheckBoxes[ event->data.ctlEnter.controlID - IDC_1stCHECKBOX ] = event->data.ctlSelect.on;
    	fHandled = true;
    	break;

      case IDC_SUMMARY_COPY:
      {
        UInt16 startPosition, endPosition;
        FldGetSelection( pVars->pSummary, &startPosition, &endPosition );
        if ( startPosition == endPosition )
	  FldSetSelection( pVars->pSummary, 0, FldGetTextLength( pVars->pSummary ) );

        FldCopy( pVars->pSummary ); 	
    	fHandled = true;
        break;
      }
    }
    break;

  default:
    break;
  }

return fHandled;
}

/*##################################################################*/
void EnableCtrls ( TGlobals *pVars, UInt16 From, UInt16 To, Boolean OnOff )
/*##################################################################*/
{
  UInt16 Ctrl;

  for ( Ctrl = From ; Ctrl <= To ; Ctrl++ )
  {
    int Index = FrmGetObjectIndex( pVars->frm, Ctrl );

#ifndef _OS35ANDABOVE

    if ( Ctrl >= IDC_TAB_FROM_STYLUS && Ctrl <= IDC_TAB_TO_KEYS && 
	 frmListObj == FrmGetObjectType( pVars->frm, Index ) )
       ((ListPtr)FrmGetObjectPtr( pVars->frm, Index ))->attr.usable = OnOff;

#endif

    if ( OnOff )
      FrmShowObject( pVars->frm, Index );
    else
      FrmHideObject( pVars->frm, Index );
  }
}
/*##################################################################*/
void SetTab ( TGlobals *pVars )
/*##################################################################*/
{
  SetTrigList( pVars, pVars->Prefs.iTab, IDC_LIST_TAB );

#ifndef _OS35ANDABOVE

  FrmEraseForm( pVars->frm ); // OS < 3.5

#endif 

  EnableCtrls( pVars, IDC_TAB_FROM_STYLUS, IDC_TAB_TO_STYLUS, pVars->Prefs.iTab == tSTYLUS );
  EnableCtrls( pVars, IDC_TAB_FROM_KEYS, IDC_TAB_TO_KEYS, pVars->Prefs.iTab == tKEYS );
  EnableCtrls( pVars, IDC_TAB_FROM_MORE, IDC_TAB_TO_MORE, pVars->Prefs.iTab == tMORE );
  EnableCtrls( pVars, IDC_TAB_FROM_MOREaSUMMARY_NOT, IDC_TAB_TO_MOREaSUMMARY_NOT, pVars->Prefs.iTab != tMORE && pVars->Prefs.iTab != tSUMMARY );
  EnableCtrls( pVars, IDC_TAB_FROM_SUMMARY, IDC_TAB_TO_SUMMARY, pVars->Prefs.iTab == tSUMMARY );

  if ( pVars->Prefs.iTab == tSUMMARY )
  {
    MemHandle FieldHandle = (MemHandle)FldGetTextHandle( pVars->pSummary );

    if ( NULL == FieldHandle )
      FieldHandle = (MemHandle)MemHandleNew( SUMMARYSIZE );

    if ( NULL != FieldHandle )
    {
      int KeyStyle, KeySec, KeyPrim;
      int From, To;
      Char* pMemo;
      Char* pStr;
      UInt32 dwAction;
      int Count;
      Char* pszAction;

      pMemo = MemHandleLock( FieldHandle );
      pStr = pMemo;

      pMemo[0] = '\0';
      Count = 0;

      for ( KeyPrim = KEYPRIMCOUNT ; --KeyPrim >= 0 ; )
        for ( KeySec = kCOUNT ; --KeySec >= 0 ; )
          for ( KeyStyle = sKEYSTYLECOUNT ; --KeyStyle >= 0 ; )
            if ( 0 != ( dwAction = pVars->Prefs.aKeys[ KeyIndex( KeyPrim, KeySec, KeyStyle ) ] ) )
            {
	      pszAction = GetActionText ( pVars, dwAction );

	      if ( NULL != pszAction )
      		pStr += StrPrintF( pStr,
				   gszP_Keys,
				   ++Count,
				   (Char*)pszAction,
				   GetLstText ( pVars, IDC_LIST_KEYSTYLE, KeyStyle ),
				   GetLstText ( pVars, IDC_LIST_KEYPRIM, KeyPrim ),
				   kNONE == KeySec ? gszEmpty : gszP_KeysAnd,
				   kNONE == KeySec ? gszEmpty : GetLstText ( pVars, IDC_LIST_KEYSEC, KeySec )
				   );
            }

      for ( From = FROMCOUNT ; --From >= 0 ; )
        for ( To = TOCOUNT ; --To >= 0 ; )
          if ( 0 != ( dwAction = pVars->Prefs.aStrokes[ To * FROMCOUNT + From ] ) )
          {
	    pszAction = GetActionText ( pVars, dwAction );

	    if ( NULL != pszAction )
      	      pStr += StrPrintF( pStr,
	      			 gszP_Stylus,
				 ++Count,
	      			 (Char*)pszAction,
	      			 GetLstText ( pVars, IDC_LIST_FROM, From ),
	      			 GetLstText ( pVars, IDC_LIST_TO, To )
	      			 );
          }

      MemHandleUnlock( FieldHandle );
      FldSetTextHandle( pVars->pSummary, (MemHandle)FieldHandle );
    }
  }

  FrmDrawForm( pVars->frm );
}
/*##################################################################*/
void  MyLstSetSelection( ListPtr List, int Item)
/*##################################################################*/
{
  LstSetSelection( List, Item );
  LstMakeItemVisible( List, Item );
}
/*##################################################################*/
void SetKey ( TGlobals *pVars, int iKeyPrim, int iKeySec, int iKeyStyle )
/*##################################################################*/
{
  MyLstSetSelection( pVars->pListKeyPrim, iKeyPrim );
  MyLstSetSelection( pVars->pListKeySec, iKeySec );
  MyLstSetSelection( pVars->pListKeyStyle, iKeyStyle );
}
/*##################################################################*/
void SetStroke ( TGlobals *pVars, int iFrom, int iTo )
/*##################################################################*/
{
  MyLstSetSelection( pVars->pListFrom, iFrom );
  MyLstSetSelection( pVars->pListTo, iTo );
}
/*##################################################################*/
void ReadStrokeKey ( TGlobals *pVars )
/*##################################################################*/
{
  if ( pVars )
  {
    int iIndexStroke, iIndexKey;

    iIndexStroke = ( ( pVars->Prefs.iStrokeTo = LstGetSelection( pVars->pListTo ) ) * FROMCOUNT  
		   + ( pVars->Prefs.iStrokeFrom = LstGetSelection( pVars->pListFrom ) ) );

    iIndexKey = KeyIndex( pVars->Prefs.iKeyPrim = LstGetSelection( pVars->pListKeyPrim ),
        		  pVars->Prefs.iKeySec = LstGetSelection( pVars->pListKeySec ),
        		  pVars->Prefs.iKeyStyle = LstGetSelection( pVars->pListKeyStyle ) );

    if ( pVars->Prefs.iTab == tSTYLUS )
      pVars->pdwStrokeKey = &( pVars->Prefs.aStrokes[ iIndexStroke ] );
    else
      pVars->pdwStrokeKey = &( pVars->Prefs.aKeys[ iIndexKey ] );
  }
}
/*##################################################################*/
void		SetTrigList	( TGlobals *pVars, UInt16 Index, UInt16 Ctrl )
/*##################################################################*/
{
  ListPtr	pList;

  MyLstSetSelection( pList = (ListPtr)GetFrmObject( pVars, Ctrl ), Index );
  CtlSetLabel( GetFrmObject( pVars, Ctrl + 1 ), LstGetSelectionText( pList, Index ) );
}
/*##################################################################*/
void AppListChanged ( TGlobals *pVars )
/*##################################################################*/
{
  *pVars->pdwStrokeKey = pVars->dbList.dbInfoArray[ LstGetSelection( pVars->pListApp ) ].creator;
  ListsChanged( pVars );
}
/*##################################################################*/
void OtherListChanged ( TGlobals *pVars )
/*##################################################################*/
{
  *pVars->pdwStrokeKey = LstGetSelection( (ListPtr)GetFrmObject( pVars, IDC_LIST_OTHER ) ) + 1;
  ListsChanged( pVars );
}
/*##################################################################*/
void ListsChanged ( TGlobals *pVars )
/*##################################################################*/
{
  UInt16	uiToCheck;

  if ( ( pVars->Prefs.iTab == tKEYS &&  0 == StrCompare( LstGetSelectionText( pVars->pListKeyPrim, pVars->Prefs.iKeyPrim ), LstGetSelectionText( pVars->pListKeySec, pVars->Prefs.iKeySec ) ) ) )
    *pVars->pdwStrokeKey = 0;

  if ( *pVars->pdwStrokeKey )
    {
    if ( *pVars->pdwStrokeKey < 0x100 )
      {
      SetTrigList( pVars, *pVars->pdwStrokeKey - 1, IDC_LIST_OTHER );
      uiToCheck = IDC_OTHER;
      }
    else
      {
      int iIndex;

      if ( -1 == ( iIndex = DBList_GetIndexFromCreator( &(pVars->dbList), *pVars->pdwStrokeKey ) ) )
        uiToCheck = IDC_NONE;
      else
        {
        SetTrigList( pVars, iIndex, IDC_LIST_APP );
        uiToCheck = IDC_APP;
        }
      }
    }
  else
    uiToCheck = IDC_NONE;

  FrmSetControlGroupSelection ( pVars->frm, 1, uiToCheck );
}
/*##################################################################*/
Char* GetActionText ( TGlobals *pVars, UInt32 dwAction )
/*##################################################################*/
{
  if ( dwAction < 0x100 )
  {
    return GetLstText( pVars, IDC_LIST_OTHER, dwAction - 1 );
  }
  else
  {
    int iIndex;

    if ( -1 == ( iIndex = DBList_GetIndexFromCreator( &(pVars->dbList), dwAction ) ) )
      return NULL;
    else
      return pVars->dbList.listItemPtrs[iIndex];
  }
}
/*##################################################################*/
Char* GetLstText ( TGlobals *pVars, UInt16 wLst, int Index )
/*##################################################################*/
{
  return LstGetSelectionText( (ListPtr)GetFrmObject( pVars, wLst ), Index );
}
/*##################################################################*/
ControlPtr GetFrmObject ( TGlobals *pVars, UInt16 wField )
/*##################################################################*/
{
  return FrmGetObjectPtr( pVars->frm, FrmGetObjectIndex( pVars->frm, wField ) );
}
/*##################################################################*/
Int16 DBcompare ( SysDBListItemType* c1, SysDBListItemType* c2, Int32 l )
/*##################################################################*/
{
  return StrCaselessCompare( c1->name, c2->name );
}
/*##################################################################*/
void AddToDbList ( TDBlist *list, UInt16 Count, UInt16 Start, MemHandle From, UInt32 CreatorFlag )
/*##################################################################*/
{
  if ( NULL != From )
  {
    SysDBListItemType* FromItem = MemHandleLock( (MemHandle)From );
    SysDBListItemType* FromList = FromItem;
    SysDBListItemType* ToItem = list->dbInfoArray + Start;
    int i;

    for ( i = 0  ; i < (int)Count ; i++, ToItem++ , FromItem++ )
    {
      MemMove( ToItem, FromItem, sizeof( *ToItem ) );
      ToItem->creator |= CreatorFlag;
    }

    MemPtrFree( FromList );
  }
}
/*##################################################################*/
void MyListDraw ( Int16 itemNum, RectangleType *bounds, Char **itemsText )
/*##################################################################*/
{
  TGlobals *pVars;
  Char* pszText;
  SysDBListItemType *pItem;
  DmOpenRef db;

  FtrGet( HACKID, FTR_VARS, (UInt32*)&pVars );

  pItem = pVars->dbList.dbInfoArray + itemNum;

  FntSetFont( pItem->creator & ( ALLCREATORFLAGS ) ? stdFont : boldFont );

  db = DmOpenDatabase( pItem->cardNo, pItem->dbID, dmModeReadOnly );
  if ( NULL != db )
  {
    MemHandle hIcon = DmGet1Resource( iconType, 1001 );

    if ( NULL == hIcon )
      hIcon = DmGetResource( iconType, defaultAppSmallIconBitmap );

    if ( NULL != hIcon )
    {
      BitmapPtr pBmp = MemHandleLock( hIcon );

      WinDrawBitmap( pBmp, 
	  	     bounds->topLeft.x + ( 15 - pBmp->width ) / 2,
	  	     bounds->topLeft.y + 1 );

      MemHandleUnlock( hIcon );
      DmReleaseResource( hIcon );
    }

    DmCloseDatabase( db );
  }

  pszText = itemsText[ itemNum ];
  WinDrawChars( pszText, StrLen( pszText ), bounds->topLeft.x + 17, bounds->topLeft.y );
}
/*##################################################################*/
Int16 DBList_GetIndexFromCreator ( TDBlist *list, UInt32 creator )
/*##################################################################*/
{
  int i;

  for ( i = list->dbCount ; --i >= 0 ; )
    if ( creator == list->dbInfoArray[i].creator )
      return i;
    
  return -1;
}
/*##################################################################*/
